
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Blockly Custom Blocks</title>
  <script type="module">
    import * as Blockly from '@johnnycubides/blockly-catalejo';
    import { luaGenerator } from "@johnnycubides/blockly-catalejo/lua";

    /** Referencia de un generador de código en función del lenguaje del plugin */
    function getGenerator(plugin){
      if(plugin.lang == "lua"){
        return luaGenerator;
      }
    }

    /** Referencia a platadormas */
    let platforms = [];
    /** Referencia al workspace */
    let workspace;

    /** Agregar plugin en platform */
    function addPlugin(platforms, platform) {
      platforms[platform.name] = {
        lang: platform.lang,
        init: platform.init,
        generateCode: platform.generateCode,
        toolbox: platform.toolbox,
      }
    }

    /** Agregar plugins */
    function addPlugins(plugins){
      for (let index = 0; index < plugins.length; index++) {
        addPlugin(platforms, plugins[index])
      }
    }

    // TODO: platform depende del archivo cargado
    const platform = "nodemcu";
    // TODO: se debe independizar la creación del toolbox del workspace
    // El toolbox cambia dependiendo del archivo cargado
    // Por tanto esta función requiere modificación.
    function setWorkspace(platform){
      workspace = Blockly.inject('blocklyDiv', {
      toolbox: platforms[platform].toolbox,
      });
    }

    /** Iniciar los plugins recorriendo plataforms */
    function initPlugins(){
      // Agregando customs blocks
      Object.keys(platforms).forEach(key => {
        platforms[key].init(Blockly, getGenerator(platforms[key]), workspace);
      })
    }

    /** Iniciar plugins, función vista en plugins */
    function startPlugins(plugins){
      // Los plugins deben exsitir
      if(plugins != undefined &&  plugins.length > 0){
        // setWorkspace
        addPlugins(plugins);
        setWorkspace(platform);
        initPlugins();
      }
    }

    //-- START --
    // Vista disponible para el usuario
    import * as nodemcu from "/src/main.ts";
    const plugins = [
      nodemcu,
    ]
  
    startPlugins(plugins);
    // -- ENDS --

    // // Seleccionar un workspace
    // const workspace = Blockly.inject('blocklyDiv', {
    //   toolbox: platforms[platform].toolbox,
    // });
    // // Inyectando bloques
    // platforms[platform].init(Blockly, getGenerator(platforms[platform].lang), workspace);

    // Función run() para traductor de bloques
    function run(){
      var code = platforms[platform].generateCode();
      console.log(code);
      alert(code);
    }

    // Asociando el evento para el botón run, en vista de que esta
    // descripción se representa a modo de "module" de javascript.
    document.addEventListener('DOMContentLoaded', () => {
      const button = document.querySelector('#runButton') ;
      button.addEventListener("click", run);
    });
  </script>
</head>
<body>
  <h4>Blockly Custom Blocks</h4>
  <button id="runButton">RUN</button>
  <div id="blocklyDiv" style="height: 700px; width: 900px;"></div>
  <xml id="toolbox" style="display: none">
    <block type="custom_block"></block>
  </xml>
</body>
</html>
